/* transform.sas */ options nocenter macrogen;
/*%let drive       =G; *f[^(CSVt@C)ۑĂhCu;*/
/*%let path        =&drive:\S\Sf[^\ϐƃx;*tH_ϐƃxpathݒ;*/
/*%let tokumei_path=&drive:\S\Sf[^\Sf[^; *f[^(CSVt@C)ۑꏊ;*/
/*%let SASds_path  =&drive:\S\Sf[^\Sf[^\SASds;       *SAS datasetۑꏊ;*/
/*%let SASpgm      =&drive:\S\Sf[^\program;                *SAS programۑꏊ;*/

libname zensho "&SASds_path";

%macro transform(year,F_T);
filename out1 "&SASpgm\RelationalDB&year&F_T..sas"; 
*JԂϐ̃f[^Zbg쐬SASvO;

proc sort data=zensho.repeat_var_table&year&F_T out=repeatTB;
  by Llabel descending repeatNo descending varNo; run;

/*proc print data=repeatTB (obs=200); title "after sort: &year&F_T"; run;*/

data repeatVar; set repeatTB (drop=at next_at); by Llabel descending repeatNo;
  if first.Llabel then do; variableNo=0; end;
  variableNo+1; 
  if last.repeatNo;
run;

/*proc print data=repeatVar; title "List of all Llabel: &year&F_T"; run;*/

data repeatVar (drop=variableNo); set; by Llabel; retain howmanyVar;
  if first.Llabel then howmanyVar=variableNo;
run;

proc sort; by varNo; run; *̏ɖ߂;

proc print; title "data=repeatVar  List of all Llabel sorted by varNo: &year&F_T"; run;

data repeatVar; set; retain prev_Llabel;
  if Llabel NE prev_Llabel then do; LlabelNo+1; prev_Llabel=Llabel; end; run;

proc print;
  title "data=repeatVar  List of all Llabel sorted by varNo: &year&F_T with LlabelNo"; run;

data program (keep=programCode); set repeatVar; by LlabelNo;
  length programCode $ 300; *쐬vO1s𑽂̕߂ɐݒ;
  length start  $ 5;
  length dsNo   $ 5;
  length fin    $ 5;
  length xstart $ 5;
  length xmade  $ 5;

  length ds_startNo $ 10;
  length ds_endNo   $ 10;

  retain absolute_start "     ";
  retain dsNo "        ";

  if _N_=1 then 
      do; programCode="/* RelationalDB.sas */"; output;
          programCode="*JԂϐ̃f[^ZbgQ쐬SASvO;";
                       output;
      end;
  if first.LlabelNo
      then do; absolute_start=varNo; 
               dsNo=LlabelNo*10000;*f[^Zbgx̌ɕtԍdsNoݒ;
           end;
  start=varNo;
  fin=varNo+howmanyVar-1;
  dsNo=dsNo+1;
            
  programCode="data " || compress("x" || dsNo) || "; " ||
              "set "  || compress("zensho.repeat&year" || "&F_T") ||"; " ||
              "keep idno " || compress("var" || start || "-var" || fin|| ";");
  output;

  xstart=start;
  do i=1 to howmanyVar;
      if i=1 then  xmade =absolute_start; 
      programCode="rename " || compress("var" || xstart || "=var" || xmade || ";"); output;
      xstart=xstart+1;
      xmade=xmade+1;
      if i=howmanyVar then do; programCode="run;"; output; end;
  end;

  if last.LlabelNo
   then do;ds_startNo=LlabelNo*10000+1;
           ds_endNo  =ds_startNo+repeatNo-1;
           *쐬f[^ZbgSďcɕ閽ߕ;
           programCode="data " || compress("zensho.RDB&year.&F_T" || LlabelNo) || "; " || "set " 
                    || compress("x" || ds_startNo || "-" || "x" || ds_endNo) || "; " || "run;";
           output;

           programCode="proc sort; by idno; run;"; output; *܂łŌJԂϐ̐`I;

           * ȉŁASϐlobservation폜 *;
           programCode="proc datasets library=work; contents data="
                  || compress("zensho.RDB&year.&F_T" || LlabelNo) || " out=varTable ; run; quit;";
           output;

           programCode="proc print data=varTable; "
                  || "title 'data=varTable ϐXg:" || compress("zensho.RDB&year.&F_T" || LlabelNo)
                  || "'; run;"                                             ; output;
           programCode="data _null_; set; if _N_=3 then call symput('chkVname',name); run;";
                                              *3Ԗڂ̕ϐŌl̔f;     output; 
           programCode="data " || compress("zensho.RDB&year.&F_T" || LlabelNo) ||";" ; output;
           programCode="set  " || compress("zensho.RDB&year.&F_T" || LlabelNo) ||";" ; output;
           programCode="if &chkVname=' ' then delete; run;"                   ; output;
                       *SČlobservation폜;
           programCode="proc print data= " || compress("zensho.RDB&year.&F_T" || LlabelNo) || "(obs=10);"
                                                                              ; output;
           programCode="title data="       || compress("zensho.RDB&year.&F_T" || LlabelNo) || "(obs=10)"
                  || ": RDB&year&F_T: After deleting missing obs;"  || "run;"; output;
        end;
run;

data _null_; set program; file out1; put programCode; run;

%include "&SASpgm\RelationalDB&year&F_T..sas";
%mend;

data _null_; current=time(); put " sJn  " current TIME.; run;

%transform(1994,T);
%transform(1994,F);
%transform(1999,T);
%transform(1999,F);
%transform(2004,T);
%transform(2004,F);

data _null_; current=time(); put " sI  " current TIME.; run;


